package b4a.ex2_HC06_leds;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.ex2_HC06_leds", "b4a.ex2_HC06_leds.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.ex2_HC06_leds", "b4a.ex2_HC06_leds.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static boolean _ld3 = false;
public static boolean _ld5 = false;
public static boolean _ld6 = false;
public static boolean _ld4 = false;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.objects.streams.File.TextReaderWrapper _textreader1 = null;
public static anywheresoftware.b4a.objects.streams.File.TextWriterWrapper _textwriter1 = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public static boolean _connected = false;
public anywheresoftware.b4a.objects.LabelWrapper _lblld3 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblld5 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblld6 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblld4 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtlog = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblreset = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 43;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1024);
 BA.debugLineNum = 46;BA.debugLine="Activity.LoadLayout(\"main\")";
Debug.ShouldStop(8192);
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 BA.debugLineNum = 48;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(32768);
if (_firsttime) { 
 BA.debugLineNum = 49;BA.debugLine="Serial1.Initialize(\"Serial1\")			'initialize the serial port";
Debug.ShouldStop(65536);
Debug.DebugWarningEngine.CheckInitialize(_serial1);_serial1.Initialize("Serial1");
 BA.debugLineNum = 50;BA.debugLine="Timer1.Initialize(\"Timer1\", 200)		'initialize Timer1 to create an event every 200ms";
Debug.ShouldStop(131072);
Debug.DebugWarningEngine.CheckInitialize(_timer1);_timer1.Initialize(processBA,"Timer1",(long)(200));
 };
 BA.debugLineNum = 52;BA.debugLine="Activity.AddMenuItem(\"Connect\", \"mnuConnect\")";
Debug.ShouldStop(524288);
mostCurrent._activity.AddMenuItem("Connect","mnuConnect");
 BA.debugLineNum = 53;BA.debugLine="Activity.AddMenuItem(\"Disconnect\", \"mnuDisconnect\")";
Debug.ShouldStop(1048576);
mostCurrent._activity.AddMenuItem("Disconnect","mnuDisconnect");
 BA.debugLineNum = 54;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 64;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(-2147483648);
 BA.debugLineNum = 66;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 56;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 57;BA.debugLine="If Serial1.IsEnabled = False Then";
Debug.ShouldStop(16777216);
if (_serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 58;BA.debugLine="Msgbox(\"Please enable Bluetooth.\", \"\")";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.Msgbox("Please enable Bluetooth.","",mostCurrent.activityBA);
 }else {
 BA.debugLineNum = 60;BA.debugLine="Serial1.Listen 							'listen for incoming connections";
Debug.ShouldStop(134217728);
_serial1.Listen(processBA);
 };
 BA.debugLineNum = 62;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 47989, new int[] {7}, "8350f166-eb53-48c8-9d83-4ff280ef5c0c");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 31;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 35;BA.debugLine="Dim lblLD3 As Label";
mostCurrent._lblld3 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Dim lblLD5 As Label";
mostCurrent._lblld5 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim lblLD6 As Label";
mostCurrent._lblld6 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Dim lblLD4 As Label";
mostCurrent._lblld4 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Dim txtLog As EditText";
mostCurrent._txtlog = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim lblReset As Label";
mostCurrent._lblreset = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _lblld3_click() throws Exception{
		Debug.PushSubsStack("lblLD3_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 111;BA.debugLine="Sub lblLD3_Click";
Debug.ShouldStop(16384);
 BA.debugLineNum = 112;BA.debugLine="If connected Then													'only apply if connected to a bluetooth device";
Debug.ShouldStop(32768);
if (_connected) { 
 BA.debugLineNum = 113;BA.debugLine="If LD3 Then														'if the button is ON";
Debug.ShouldStop(65536);
if (_ld3) { 
 BA.debugLineNum = 114;BA.debugLine="LD3 = False";
Debug.ShouldStop(131072);
_ld3 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 115;BA.debugLine="lblLD3.Color = Colors.Gray";
Debug.ShouldStop(262144);
mostCurrent._lblld3.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 116;BA.debugLine="TextWriter1.WriteLine(\"OrangeOFF\")							'write a string to the serial port to switch OFF the corresponding LED";
Debug.ShouldStop(524288);
_textwriter1.WriteLine("OrangeOFF");
 }else {
 BA.debugLineNum = 118;BA.debugLine="LD3 = True";
Debug.ShouldStop(2097152);
_ld3 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 119;BA.debugLine="lblLD3.Color = Colors.RGB(255,128,0)	'orange";
Debug.ShouldStop(4194304);
mostCurrent._lblld3.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 BA.debugLineNum = 120;BA.debugLine="TextWriter1.WriteLine(\"OrangeON\")		   					'write a string to the serial port to switch ON the corresponding LED";
Debug.ShouldStop(8388608);
_textwriter1.WriteLine("OrangeON");
 };
 BA.debugLineNum = 122;BA.debugLine="TextWriter1.Flush												'clear the serialport TX buffer to make sure the previous string gets sent";
Debug.ShouldStop(33554432);
_textwriter1.Flush();
 };
 BA.debugLineNum = 124;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lblld4_click() throws Exception{
		Debug.PushSubsStack("lblLD4_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 125;BA.debugLine="Sub lblLD4_Click";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 126;BA.debugLine="If connected Then";
Debug.ShouldStop(536870912);
if (_connected) { 
 BA.debugLineNum = 127;BA.debugLine="If LD4 Then";
Debug.ShouldStop(1073741824);
if (_ld4) { 
 BA.debugLineNum = 128;BA.debugLine="LD4 = False";
Debug.ShouldStop(-2147483648);
_ld4 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 129;BA.debugLine="lblLD4.Color = Colors.Gray";
Debug.ShouldStop(1);
mostCurrent._lblld4.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 130;BA.debugLine="TextWriter1.WriteLine(\"GreenOFF\")";
Debug.ShouldStop(2);
_textwriter1.WriteLine("GreenOFF");
 }else {
 BA.debugLineNum = 132;BA.debugLine="LD4 = True";
Debug.ShouldStop(8);
_ld4 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 133;BA.debugLine="lblLD4.Color = Colors.Green";
Debug.ShouldStop(16);
mostCurrent._lblld4.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 BA.debugLineNum = 134;BA.debugLine="TextWriter1.WriteLine(\"GreenON\")";
Debug.ShouldStop(32);
_textwriter1.WriteLine("GreenON");
 };
 BA.debugLineNum = 136;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(128);
_textwriter1.Flush();
 };
 BA.debugLineNum = 138;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lblld5_click() throws Exception{
		Debug.PushSubsStack("lblLD5_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 153;BA.debugLine="Sub lblLD5_Click";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 154;BA.debugLine="If connected Then";
Debug.ShouldStop(33554432);
if (_connected) { 
 BA.debugLineNum = 155;BA.debugLine="If LD5 Then";
Debug.ShouldStop(67108864);
if (_ld5) { 
 BA.debugLineNum = 156;BA.debugLine="LD5 = False";
Debug.ShouldStop(134217728);
_ld5 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 157;BA.debugLine="lblLD5.Color = Colors.Gray";
Debug.ShouldStop(268435456);
mostCurrent._lblld5.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 158;BA.debugLine="TextWriter1.WriteLine(\"RedOFF\")";
Debug.ShouldStop(536870912);
_textwriter1.WriteLine("RedOFF");
 }else {
 BA.debugLineNum = 160;BA.debugLine="LD5 = True";
Debug.ShouldStop(-2147483648);
_ld5 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 161;BA.debugLine="lblLD5.Color = Colors.Red";
Debug.ShouldStop(1);
mostCurrent._lblld5.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 BA.debugLineNum = 162;BA.debugLine="TextWriter1.WriteLine(\"RedON\")";
Debug.ShouldStop(2);
_textwriter1.WriteLine("RedON");
 };
 BA.debugLineNum = 164;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(8);
_textwriter1.Flush();
 };
 BA.debugLineNum = 166;BA.debugLine="End Sub";
Debug.ShouldStop(32);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lblld6_click() throws Exception{
		Debug.PushSubsStack("lblLD6_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 139;BA.debugLine="Sub lblLD6_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 140;BA.debugLine="If connected Then";
Debug.ShouldStop(2048);
if (_connected) { 
 BA.debugLineNum = 141;BA.debugLine="If LD6 Then";
Debug.ShouldStop(4096);
if (_ld6) { 
 BA.debugLineNum = 142;BA.debugLine="LD6 = False";
Debug.ShouldStop(8192);
_ld6 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 143;BA.debugLine="lblLD6.Color = Colors.Gray";
Debug.ShouldStop(16384);
mostCurrent._lblld6.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 144;BA.debugLine="TextWriter1.WriteLine(\"BlueOFF\")";
Debug.ShouldStop(32768);
_textwriter1.WriteLine("BlueOFF");
 }else {
 BA.debugLineNum = 146;BA.debugLine="LD6 = True";
Debug.ShouldStop(131072);
_ld6 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 147;BA.debugLine="lblLD6.Color = Colors.Blue";
Debug.ShouldStop(262144);
mostCurrent._lblld6.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 148;BA.debugLine="TextWriter1.WriteLine(\"BlueON\")";
Debug.ShouldStop(524288);
_textwriter1.WriteLine("BlueON");
 };
 BA.debugLineNum = 150;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(2097152);
_textwriter1.Flush();
 };
 BA.debugLineNum = 152;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lblreset_click() throws Exception{
		Debug.PushSubsStack("lblReset_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 169;BA.debugLine="Sub lblReset_Click";
Debug.ShouldStop(256);
 BA.debugLineNum = 170;BA.debugLine="If connected Then";
Debug.ShouldStop(512);
if (_connected) { 
 BA.debugLineNum = 171;BA.debugLine="TextWriter1.WriteLine(\"OrangeOFF\")";
Debug.ShouldStop(1024);
_textwriter1.WriteLine("OrangeOFF");
 BA.debugLineNum = 172;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(2048);
_textwriter1.Flush();
 BA.debugLineNum = 173;BA.debugLine="TextWriter1.WriteLine(\"RedOFF\")";
Debug.ShouldStop(4096);
_textwriter1.WriteLine("RedOFF");
 BA.debugLineNum = 174;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(8192);
_textwriter1.Flush();
 BA.debugLineNum = 175;BA.debugLine="TextWriter1.WriteLine(\"BlueOFF\")";
Debug.ShouldStop(16384);
_textwriter1.WriteLine("BlueOFF");
 BA.debugLineNum = 176;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(32768);
_textwriter1.Flush();
 BA.debugLineNum = 177;BA.debugLine="TextWriter1.WriteLine(\"GreenOFF\")";
Debug.ShouldStop(65536);
_textwriter1.WriteLine("GreenOFF");
 BA.debugLineNum = 178;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(131072);
_textwriter1.Flush();
 BA.debugLineNum = 180;BA.debugLine="lblLD3.Color = Colors.Gray";
Debug.ShouldStop(524288);
mostCurrent._lblld3.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 181;BA.debugLine="lblLD5.Color = Colors.Gray";
Debug.ShouldStop(1048576);
mostCurrent._lblld5.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 182;BA.debugLine="lblLD6.Color = Colors.Gray";
Debug.ShouldStop(2097152);
mostCurrent._lblld6.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 183;BA.debugLine="lblLD4.Color = Colors.Gray";
Debug.ShouldStop(4194304);
mostCurrent._lblld4.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 185;BA.debugLine="LD3 = False";
Debug.ShouldStop(16777216);
_ld3 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 186;BA.debugLine="LD5 = False";
Debug.ShouldStop(33554432);
_ld5 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 187;BA.debugLine="LD6 = False";
Debug.ShouldStop(67108864);
_ld6 = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 188;BA.debugLine="LD4 = False";
Debug.ShouldStop(134217728);
_ld4 = anywheresoftware.b4a.keywords.Common.False;
 };
 BA.debugLineNum = 190;BA.debugLine="End Sub";
Debug.ShouldStop(536870912);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _lblreset_longclick() throws Exception{
		Debug.PushSubsStack("lblReset_LongClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 193;BA.debugLine="Sub lblReset_LongClick";
Debug.ShouldStop(1);
 BA.debugLineNum = 194;BA.debugLine="If connected Then";
Debug.ShouldStop(2);
if (_connected) { 
 BA.debugLineNum = 195;BA.debugLine="TextWriter1.WriteLine(\"OrangeON\")";
Debug.ShouldStop(4);
_textwriter1.WriteLine("OrangeON");
 BA.debugLineNum = 196;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(8);
_textwriter1.Flush();
 BA.debugLineNum = 197;BA.debugLine="TextWriter1.WriteLine(\"RedON\")";
Debug.ShouldStop(16);
_textwriter1.WriteLine("RedON");
 BA.debugLineNum = 198;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(32);
_textwriter1.Flush();
 BA.debugLineNum = 199;BA.debugLine="TextWriter1.WriteLine(\"BlueON\")";
Debug.ShouldStop(64);
_textwriter1.WriteLine("BlueON");
 BA.debugLineNum = 200;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(128);
_textwriter1.Flush();
 BA.debugLineNum = 201;BA.debugLine="TextWriter1.WriteLine(\"GreenON\")";
Debug.ShouldStop(256);
_textwriter1.WriteLine("GreenON");
 BA.debugLineNum = 202;BA.debugLine="TextWriter1.Flush";
Debug.ShouldStop(512);
_textwriter1.Flush();
 BA.debugLineNum = 204;BA.debugLine="lblLD3.Color = Colors.RGB(255,128,0)	'orange";
Debug.ShouldStop(2048);
mostCurrent._lblld3.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(128),(int)(0)));
 BA.debugLineNum = 205;BA.debugLine="lblLD5.Color = Colors.Red";
Debug.ShouldStop(4096);
mostCurrent._lblld5.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 BA.debugLineNum = 206;BA.debugLine="lblLD6.Color = Colors.Blue";
Debug.ShouldStop(8192);
mostCurrent._lblld6.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 207;BA.debugLine="lblLD4.Color = Colors.Green";
Debug.ShouldStop(16384);
mostCurrent._lblld4.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 BA.debugLineNum = 209;BA.debugLine="LD3 = True";
Debug.ShouldStop(65536);
_ld3 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 210;BA.debugLine="LD5 = True";
Debug.ShouldStop(131072);
_ld5 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 211;BA.debugLine="LD6 = True";
Debug.ShouldStop(262144);
_ld6 = anywheresoftware.b4a.keywords.Common.True;
 BA.debugLineNum = 212;BA.debugLine="LD4 = True";
Debug.ShouldStop(524288);
_ld4 = anywheresoftware.b4a.keywords.Common.True;
 };
 BA.debugLineNum = 214;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _mnuconnect_click() throws Exception{
		Debug.PushSubsStack("mnuConnect_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
int _res = 0;
 BA.debugLineNum = 68;BA.debugLine="Sub mnuConnect_Click";
Debug.ShouldStop(8);
 BA.debugLineNum = 69;BA.debugLine="Dim PairedDevices As Map";
Debug.ShouldStop(16);
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();Debug.locals.put("PairedDevices", _paireddevices);
 BA.debugLineNum = 70;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
Debug.ShouldStop(32);
_paireddevices = _serial1.GetPairedDevices();Debug.locals.put("PairedDevices", _paireddevices);
 BA.debugLineNum = 71;BA.debugLine="Dim l As List";
Debug.ShouldStop(64);
_l = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("l", _l);
 BA.debugLineNum = 72;BA.debugLine="l.Initialize";
Debug.ShouldStop(128);
_l.Initialize();
 BA.debugLineNum = 73;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
Debug.ShouldStop(256);
{
final double step42 = 1;
final double limit42 = (int)(_paireddevices.getSize()-1);
for (_i = (int)(0); (step42 > 0 && _i <= limit42) || (step42 < 0 && _i >= limit42); _i += step42) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 74;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i))";
Debug.ShouldStop(512);
_l.Add(_paireddevices.GetKeyAt(_i));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 76;BA.debugLine="Dim res As Int";
Debug.ShouldStop(2048);
_res = 0;Debug.locals.put("res", _res);
 BA.debugLineNum = 77;BA.debugLine="res = InputList(l, \"Choose device\", -1) 	'show list with paired devices";
Debug.ShouldStop(4096);
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device",(int)(-1),mostCurrent.activityBA);Debug.locals.put("res", _res);
 BA.debugLineNum = 78;BA.debugLine="If res <> DialogResponse.CANCEL Then";
Debug.ShouldStop(8192);
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 BA.debugLineNum = 79;BA.debugLine="Serial1.Connect(PairedDevices.Get(l.Get(res))) 'convert the name to mac address";
Debug.ShouldStop(16384);
_serial1.Connect(processBA,String.valueOf(_paireddevices.Get(_l.Get(_res))));
 };
 BA.debugLineNum = 81;BA.debugLine="End Sub";
Debug.ShouldStop(65536);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _mnudisconnect_click() throws Exception{
		Debug.PushSubsStack("mnuDisconnect_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 97;BA.debugLine="Sub mnuDisconnect_Click";
Debug.ShouldStop(1);
 BA.debugLineNum = 98;BA.debugLine="Serial1.Disconnect";
Debug.ShouldStop(2);
_serial1.Disconnect();
 BA.debugLineNum = 99;BA.debugLine="connected = False";
Debug.ShouldStop(4);
_connected = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 100;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim LD3 As Boolean = False";
_ld3 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 19;BA.debugLine="Dim LD5 As Boolean = False";
_ld5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 20;BA.debugLine="Dim LD6 As Boolean = False";
_ld6 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 21;BA.debugLine="Dim LD4 As Boolean = False";
_ld4 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 24;BA.debugLine="Dim Serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 25;BA.debugLine="Dim TextReader1 As TextReader";
_textreader1 = new anywheresoftware.b4a.objects.streams.File.TextReaderWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim TextWriter1 As TextWriter";
_textwriter1 = new anywheresoftware.b4a.objects.streams.File.TextWriterWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim Timer1 As Timer";
_timer1 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 28;BA.debugLine="Dim connected As Boolean";
_connected = false;
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
		Debug.PushSubsStack("Serial1_Connected (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Success", _success);
 BA.debugLineNum = 83;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
Debug.ShouldStop(262144);
 BA.debugLineNum = 84;BA.debugLine="If Success Then";
Debug.ShouldStop(524288);
if (_success) { 
 BA.debugLineNum = 85;BA.debugLine="ToastMessageShow(\"Connected successfully\", False)";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connected successfully",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 86;BA.debugLine="TextReader1.Initialize(Serial1.InputStream)";
Debug.ShouldStop(2097152);
_textreader1.Initialize(_serial1.getInputStream());
 BA.debugLineNum = 87;BA.debugLine="TextWriter1.Initialize(Serial1.OutputStream)";
Debug.ShouldStop(4194304);
_textwriter1.Initialize(_serial1.getOutputStream());
 BA.debugLineNum = 88;BA.debugLine="Timer1.Enabled = True";
Debug.ShouldStop(8388608);
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 89;BA.debugLine="connected = True";
Debug.ShouldStop(16777216);
_connected = anywheresoftware.b4a.keywords.Common.True;
 }else {
 BA.debugLineNum = 91;BA.debugLine="connected = False";
Debug.ShouldStop(67108864);
_connected = anywheresoftware.b4a.keywords.Common.False;
 BA.debugLineNum = 92;BA.debugLine="Timer1.Enabled = False";
Debug.ShouldStop(134217728);
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 93;BA.debugLine="Msgbox(LastException.Message, \"Error connecting.\")";
Debug.ShouldStop(268435456);
anywheresoftware.b4a.keywords.Common.Msgbox(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),"Error connecting.",mostCurrent.activityBA);
 };
 BA.debugLineNum = 95;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _timer1_tick() throws Exception{
		Debug.PushSubsStack("Timer1_Tick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 102;BA.debugLine="Sub Timer1_Tick";
Debug.ShouldStop(32);
 BA.debugLineNum = 103;BA.debugLine="If connected Then";
Debug.ShouldStop(64);
if (_connected) { 
 BA.debugLineNum = 104;BA.debugLine="If TextReader1.Ready Then 										'check if there is any data waiting to be read";
Debug.ShouldStop(128);
if (_textreader1.Ready()) { 
 BA.debugLineNum = 105;BA.debugLine="txtLog.Text = txtLog.Text & TextReader1.ReadLine & CRLF		'add the incoming message to the txtlog and go to the next line of txtlog";
Debug.ShouldStop(256);
mostCurrent._txtlog.setText((Object)(mostCurrent._txtlog.getText()+_textreader1.ReadLine()+anywheresoftware.b4a.keywords.Common.CRLF));
 BA.debugLineNum = 106;BA.debugLine="txtLog.SelectionStart = txtLog.Text.Length					'move to the last character in the txtlog to create \"scrolling\" efect";
Debug.ShouldStop(512);
mostCurrent._txtlog.setSelectionStart(mostCurrent._txtlog.getText().length());
 };
 };
 BA.debugLineNum = 109;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"LD3",_ld3,"LD5",_ld5,"LD6",_ld6,"LD4",_ld4,"Serial1",_serial1,"TextReader1",_textreader1,"TextWriter1",_textwriter1,"Timer1",_timer1,"connected",_connected,"lblLD3",_lblld3,"lblLD5",_lblld5,"lblLD6",_lblld6,"lblLD4",_lblld4,"txtLog",_txtlog,"lblReset",_lblreset};
}
}
